#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	640
#define	MAXHEIGHT	200

void	fput4b(int,FILE *);
void	fput2b(int,FILE *);

void	convpic(int picsize_x,int picsize_y,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[MAXWIDTH][MAXHEIGHT];
	int		c_pixel[MAXWIDTH/2][MAXHEIGHT];

	int		width,height;
	int		x,y;
	int		col;
	int		m,i,j,k;
	int		a0,a1,a2,a3,c;
	int		sft;
	int		outhigh,eqlen,deqlen;
	int		outdt4b;
	int		d0,d1;
	int		xs,ys,md;
	int		endflag,even,delta;

	int		seccnt;
	int		x0,y0;
	int		stadd;

	long int	flen;



	if (argc != 3) {
		fprintf(stderr, "Usage: convpict infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	fseek(infp,0,SEEK_SET);

	seccnt = fgetc(infp);	/* ZN^ */
	a1 = fgetc(infp);		/* 擪VRAMAhX */
	a0 = fgetc(infp);		/* 擪VRAMAhX */
	xs = fgetc(infp);		/* hbg/8 */
	ys = fgetc(infp);		/* chbg */
	md = fgetc(infp);		/* 0x00J[FȊO */

	stadd = a0 * 256 + a1;

	y0 = stadd / 80;
	x0 = stadd % 80;


	height = 200;
	width  = 640;

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	x = 0;
	y = 0;
	col = 0x07;
	endflag = 0;
	delta = 2;
	even = 1;

	if (md != 0x00) {

		while (endflag == 0) {
			c = fgetc(infp);

			if (c < 0x80) {

				a0 = fgetc(infp);

				for (i = 0;i < c;i ++) {
					sft = 0x80;
					for (j = 0;j < 8;j ++) {
						if ((sft & a0) != 0) {
							pixel[x*8+j][y] = col;
						}
						sft /= 2;
					}

					y += delta;
					if (y >= ys*2) {
						y -= delta;
						x ++;
						delta = -2;
						if (x >= xs) {
							if (even == 1) {
								even = 0;
								x = 0;
								y = 1;
								delta = 2;
							} else {
								even = 1;
								x = 0;
								y = 0;
								delta = 2;
								col *= 2;
								if (col >= 8) {
									endflag = 1;
									break;
								}
							}
						}
					} else if (y < 0) {
						y -= delta;
						x ++;
						delta = 2;
						if (x >= xs) {
							if (even == 1) {
								even = 0;
								x = 0;
								y = 1;
								delta = 2;
							} else {
								even = 1;
								x = 0;
								y = 0;
								delta = 2;
								col *= 2;
								if (col >= 8) {
									endflag = 1;
									break;
								}
							}
						}
					}

				}

			} else {
				c = (c & 0x7f);

				for (i = 0;i < c;i ++) {
					a0 = fgetc(infp);
					sft = 0x80;
					for (j = 0;j < 8;j ++) {
						if ((sft & a0) != 0) {
							pixel[x*8+j][y] = col;
						}
						sft /= 2;
					}

					y += delta;
					if (y >= ys*2) {
						y -= delta;
						x ++;
						delta = -2;
						if (x >= xs) {
							if (even == 1) {
								even = 0;
								x = 0;
								y = 1;
								delta = 2;
							} else {
								even = 1;
								x = 0;
								y = 0;
								delta = 2;
								col *= 2;
								if (col >= 8) {
									endflag = 1;
									break;
								}
							}
						}
					} else if (y < 0) {
						y -= delta;
						x ++;
						delta = 2;
						if (x >= xs) {
							if (even == 1) {
								even = 0;
								x = 0;
								y = 1;
								delta = 2;
							} else {
								even = 1;
								x = 0;
								y = 0;
								delta = 2;
								col *= 2;
								if (col >= 8) {
									endflag = 1;
									break;
								}
							}
						}
					}

				}
			}
		}

	}

	x = 0;
	y = 0;
	col = 0x01;
	endflag = 0;
	delta = 2;
	even = 1;


	while (endflag == 0) {
		c = fgetc(infp);

		if (c < 0x80) {

			a0 = fgetc(infp);

			for (i = 0;i < c;i ++) {
				sft = 0x80;
				for (j = 0;j < 8;j ++) {
					if ((sft & a0) != 0) {
						pixel[x*8+j][y] |= col;
					}
					sft /= 2;
				}

				y += delta;
				if (y >= ys*2) {
					y -= delta;
					x ++;
					delta = -2;
					if (x >= xs) {
						if (even == 1) {
							even = 0;
							x = 0;
							y = 1;
							delta = 2;
						} else {
							even = 1;
							x = 0;
							y = 0;
							delta = 2;
							col *= 2;
							if (col >= 8) {
								endflag = 1;
								break;
							}
						}
					}
				} else if (y < 0) {
					y -= delta;
					x ++;
					delta = 2;
					if (x >= xs) {
						if (even == 1) {
							even = 0;
							x = 0;
							y = 1;
							delta = 2;
						} else {
							even = 1;
							x = 0;
							y = 0;
							delta = 2;
							col *= 2;
							if (col >= 8) {
								endflag = 1;
								break;
							}
						}
					}
				}

			}

		} else {
			c = (c & 0x7f);

			for (i = 0;i < c;i ++) {
				a0 = fgetc(infp);
				sft = 0x80;
				for (j = 0;j < 8;j ++) {
					if ((sft & a0) != 0) {
						pixel[x*8+j][y] |= col;
					}
					sft /= 2;
				}

				y += delta;
				if (y >= ys*2) {
					y -= delta;
					x ++;
					delta = -2;
					if (x >= xs) {
						if (even == 1) {
							even = 0;
							x = 0;
							y = 1;
							delta = 2;
						} else {
							even = 1;
							x = 0;
							y = 0;
							delta = 2;
							col *= 2;
							if (col >= 8) {
								endflag = 1;
								break;
							}
						}
					}
				} else if (y < 0) {
					y -= delta;
					x ++;
					delta = 2;
					if (x >= xs) {
						if (even == 1) {
							even = 0;
							x = 0;
							y = 1;
							delta = 2;
						} else {
							even = 1;
							x = 0;
							y = 0;
							delta = 2;
							col *= 2;
							if (col >= 8) {
								endflag = 1;
								break;
							}
						}
					}
				}

			}
		}
	}



	convpic(xs*8,ys*2,c_pixel,pixel);

	fputc( seccnt, outfp);
	fputc( x0, outfp);
	fputc( y0, outfp);
	fputc( xs, outfp);
	fputc( ys*2, outfp);
	fputc( md, outfp);


/* f[^k */
/*
Ef[^́ASrbgP
E1st 0x7 ȏȂÂ܂܂̃f[^

E1st 0x0 ȂPoCgk
E2nd 0x4`0xF ȂA3rd 2nd JԂ
E2nd 0x0 ȂA3rd  16 JԂ
E2nd 0x1 ȂA3rd  32 JԂ
E2nd 0x2 ȂA3rd  64 JԂ
E2nd 0x3 ȂA3rd  128 JԂ

E1st 0x1`0x6 ȂQoCgk
E1st 0x3`0x6 ȂA2ndA3rd1stJԂ
E1st 0x1 ȂA2ndA3rd16JԂ
E1st 0x2 ȂA2ndA3rd32JԂ

EPŊBSrbgPʂŗ]ꍇ́AŌ 0x0 𖄂߂B
*/

	for (y = 0;y < ys*2;y ++) {
		outhigh = 1;
		for (x = 0;x < xs*4;) {

		// oCǧo
			eqlen = 0;
			a0 = c_pixel[x][y];
			for (i = x;i < xs*4;i ++) {
				a1 = c_pixel[i][y];
				if (a0 != a1) {
					break;
				}
				eqlen ++;
			}

		// QoCgǍo
			deqlen = 0;
			if (x+3 < xs*4) {
				a0 = c_pixel[x][y];
				a1 = c_pixel[x+1][y];
				for (i = x;i < xs*4-1;i +=2) {
					a2 = c_pixel[i][y];
					a3 = c_pixel[i+1][y];
					if (a0 != a2 || a1 != a3) {
						break;
					}
					deqlen ++;
				}
			}


			if (eqlen >= 4) {			// PoCgk

				outdt4b = 0x00;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				if (eqlen >= 128) {
					outdt4b = 0x03;
				} else if (eqlen >= 64) {
					outdt4b = 0x02;
				} else if (eqlen >= 32) {
					outdt4b = 0x01;
				} else if (eqlen >= 16) {
					outdt4b = 0x00;
				} else {
					outdt4b = eqlen;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				if (eqlen >= 128) {
					x += 128;
				} else if (eqlen >= 64) {
					x += 64;
				} else if (eqlen >= 32) {
					x += 32;
				} else if (eqlen >= 16) {
					x += 16;
				} else {
					x += eqlen;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else if (deqlen >= 3) {		// QoCgk

				if (deqlen >= 32) {
					outdt4b = 0x02;
				} else if (deqlen >= 16) {
					outdt4b = 0x01;
				} else if (deqlen >= 6) {
					outdt4b = 0x06;
				} else {
					outdt4b = deqlen;
				}

				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				if (deqlen >= 32) {
					x += 32*2;
				} else if (deqlen >= 16) {
					x += 16*2;
				} else if (deqlen >= 6) {
					x += 6*2;
				} else {
					x += deqlen*2;
				}

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

				outdt4b = a1;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}

			} else {					// kȂ

				outdt4b = a0;
				if (outhigh == 1) {
					d0 = ( (outdt4b & 0x0f) << 4);
					outhigh = 0;
				} else {
					d1 = (outdt4b & 0x0f);
					fputc(d0|d1,outfp);
					outhigh = 1;
				}
				x ++;

			}

		}

		outdt4b = 0x00;
		if (outhigh != 1) {
			d1 = (outdt4b & 0x0f);
			fputc(d0|d1,outfp);
		}

	}

	fseek(outfp,0,SEEK_END);
	flen = ftell(outfp);

	fseek(outfp,0,SEEK_SET);
	fputc( ((flen+0xff)/0x100) ,outfp);

	fclose(outfp);
	fclose(infp);


	return(0);
}


void	fput4b(int d,FILE *fp)
{
	int	d0,d1,d2,d3;

	d0 = (d & 0x000000ff);
	d1 = (d & 0x0000ff00) >> 8;
	d2 = (d & 0x00ff0000) >> 16;
	d3 = (d & 0xff000f00) >> 24;

	fputc(d0,fp);
	fputc(d1,fp);
	fputc(d2,fp);
	fputc(d3,fp);

	return;
}

void	fput2b(int d,FILE *fp)
{
	int	d0,d1;

	d0 = (d & 0x00ff);
	d1 = (d & 0xff00) >> 8;

	fputc(d0,fp);
	fputc(d1,fp);

	return;
}


void	convpic(int picsize_x,int picsize_y,int c_pixel[MAXWIDTH/2][MAXHEIGHT],int pixel[MAXWIDTH][MAXHEIGHT])
{
	int		x,y;

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel[x+0][y] = pixel[x*2+0][y];
		}

		for (x = 0;x < picsize_x/2 - 1;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+2][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+3][y])
			) {
				if ( (x%2) == 0) {
					c_pixel[x+0][y] = pixel[x*2+0][y];
					c_pixel[x+1][y] = pixel[x*2+3][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2+1][y];
					c_pixel[x+1][y] = pixel[x*2+2][y];
				}
			}
		}

		for (x = 0;x < picsize_x/2 - 3;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+4][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+5][y]) &&
				(pixel[x*2+2][y] == pixel[x*2+6][y]) && 
				(pixel[x*2+3][y] == pixel[x*2+7][y])
			) {

				if (pixel[x*2+0][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}

				} else if (pixel[x*2+0][y] == pixel[x*2+1][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+2][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+3][y] == pixel[x*2+0][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				}
			}
		}
	}

	return;
}

